//
// PM_Main.pas part of PuTTY Manager
//
// Created: Borland Delphi 7
//  Author: Krzysztof Markiewicz
//  www.obbo.pl
//
// This program is distributed under the terms of the GNU General Public License
//

unit PM_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Forms,
  Registry, XPMan, AFVersionCaption, ShellApi, PM_NewHost,
  ExtCtrls, NxColumnClasses, NxColumns, Controls, NxScrollControl, NxClasses,
  NxCustomGridControl, NxCustomGrid, NxGrid, ImgList, Menus, StdCtrls,
  Buttons, TLHelp32, PM_CommData, PM_XML, PM_CommFunction, PM_About,
  PM_DataModule, NxCells;

type
  TMainForm = class(TForm)
    Button1: TBitBtn;
    Button2: TBitBtn;
    Button5: TBitBtn;
    XPManifest1: TXPManifest;
    AFVersionCaption1: TAFVersionCaption;
    PopupMenu1: TPopupMenu;
    MenuList: TImageList;
    Fontsize1: TMenuItem;
    N8FS: TMenuItem;
    N9FS: TMenuItem;
    N10FS: TMenuItem;
    N11FS: TMenuItem;
    N12FS: TMenuItem;
    Visiblecols1: TMenuItem;
    COL2: TMenuItem;
    COL3: TMenuItem;
    COL4: TMenuItem;
    COL5: TMenuItem;
    COL6: TMenuItem;
    COL7: TMenuItem;
    COL8: TMenuItem;
    All1: TMenuItem;
    N3: TMenuItem;
    OnlyHost1: TMenuItem;
    N4: TMenuItem;
    StayOnTop1: TMenuItem;
    N5: TMenuItem;
    About1: TMenuItem;
    Timer1: TTimer;
    N1: TMenuItem;
    Edit1: TMenuItem;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    GridView1: TNextGrid;
    NxImageColumn1: TNxImageColumn;
    NxTextColumn1: TNxTextColumn;
    NxTextColumn2: TNxTextColumn;
    NxTextColumn3: TNxTextColumn;
    NxTextColumn4: TNxTextColumn;
    NxCheckBoxColumn1: TNxCheckBoxColumn;
    NxTextColumn5: TNxTextColumn;
    NxTextColumn6: TNxTextColumn;
    NxTextColumn7: TNxTextColumn;
    NxTextColumn8: TNxTextColumn;
    NxTextColumn9: TNxTextColumn;
    Timer2: TTimer;
    Autohide1: TMenuItem;
    Exit1: TMenuItem;
    PuTTY1: TMenuItem;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure GridView1SelectCell(Sender: TObject; ACol, ARow: Integer);
    procedure GridView1DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure GridView1MouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    procedure GridView1MouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    procedure GridView1KeyPress(Sender: TObject; var Key: Char);
    procedure Button5Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure N8FSClick(Sender: TObject);
    procedure N9FSClick(Sender: TObject);
    procedure N10FSClick(Sender: TObject);
    procedure N11FSClick(Sender: TObject);
    procedure N12FSClick(Sender: TObject);
    procedure COL2Click(Sender: TObject);
    procedure COL3Click(Sender: TObject);
    procedure COL4Click(Sender: TObject);
    procedure COL5Click(Sender: TObject);
    procedure COL6Click(Sender: TObject);
    procedure COL7Click(Sender: TObject);
    procedure COL8Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure All1Click(Sender: TObject);
    procedure OnlyHost1Click(Sender: TObject);
    procedure GridView1SortColumn(Sender: TObject; ACol: Integer; Ascending: Boolean);
    procedure StayOnTop1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Autohide1Click(Sender: TObject);
    procedure GridView1Compare(Sender: TObject; Cell1, Cell2: TCell;
      var Compare: Integer);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    procedure WMGetMinMaxInfo( var Message :TWMGetMinMaxInfo ); message WM_GETMINMAXINFO;
    procedure SetOnTop;
    procedure FormResizeX;
    procedure FormResizeY;
    procedure SetButtons;
    procedure ExecuteApp;
    procedure SetFontSize(FS:integer);
    Procedure GridColumnsVisible(col:integer);
    Procedure GridColumnsVisibleALl(t:boolean);
    Procedure ResizeColumns;
    Procedure SetColumnSize;
    Procedure GridViewStoreAndClear;
    Procedure GridViewRestore(sel:string);
    Procedure BackupPMFile;
    Procedure StoreNewHostFormPosition;
    Procedure GridColumnsShow;
    Procedure CloseApplication;
    Procedure SetNewHostFormPos;
    Procedure SetActiveDel(act:boolean);
    Function CheckRunningApp:integer;
    Function IDExist(id:string):boolean;
    Procedure HideForm;
  public
   { Public declarations }
    function FirstFreeID:integer;
    procedure XMLToGrid(s: string);
    procedure XMLHostToGrid(n: string; j: integer);
    Procedure RowToRecord(row:integer);

  end;

var
  MainForm: TMainForm;

implementation


{$R *.dfm}

Procedure TMainForm.SetColumnSize;
begin
  SetLength(ColumnsState,GridView1.Columns.Count-1);
  SetLength(ColW,GridView1.Columns.Count-1);
  ColW[1]:=4;
  ColW[2]:=4;
  ColW[3]:=3;
  ColW[4]:=3;
  ColW[5]:=1;
  ColW[6]:=2;
  ColW[7]:=3;
  ColW[8]:=5;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  if AppError then CloseApplication;
end;

Procedure TMainForm.CloseApplication;
begin
  Timer1.Enabled:=False;
  AppSettings.Left:=MainForm.Left;
  AppSettings.Top:=MainFOrm.Top;
  if not(AppError) then
    if not(WriteSettingsToXML) then
      MessageBox(Handle,'  Can'+#39+'t write to PM.xml  ','Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
  DataModule1.XML1.Active:=False;
  Close;
end;

procedure TMainForm.Button2Click(Sender: TObject);
// Exit
begin
  MainForm.Destroy;
end;

Procedure TMainForm.BackupPMFile;
begin
  if not(CopyFile('PM.xml','PM.bak',False)) then
    MessageBox(Handle,'  Can'+#39+'t create PM.xml backup file  ','Warning', MB_OK+MB_ICONWARNING);
end;

Procedure TMainForm.SetActiveDel(act:boolean);
begin
  AppSettings.InactiveDel:=act;
  if GridView1.RowCount<1 then
    Delete1.Enabled:=False
  else
    Delete1.Enabled:=not(act);
end;

Function TMainForm.CheckRunningApp:integer;
var
  H : THandle;
  Proc : TProcessEntry32;
  MyExe: string;
begin
  result:=0;
  H := CreateToolHelp32SnapShot(TH32CS_SNAPALL,0);
  Proc.dwSize:=SizeOf(Proc);
  if Integer(Process32First(H, Proc)) <> 0 then
  repeat
    if proc.th32ProcessID=GetCurrentProcessID then MyExe:=Proc.szExeFile;
  until Integer(Process32Next(H, Proc)) = 0;
  Proc.dwSize:=SizeOf(Proc);
  if Integer(Process32First(H, Proc)) <> 0 then
  repeat
    if LowerCase(Proc.szExeFile)=LowerCase(MyExe) then inc(result);
  until Integer(Process32Next(H, Proc)) = 0;
  CloseHandle(H);
  if result>1 then
    MessageBox(Handle,PAnsiChar('  Other '+MyExe+' running.  '),'Warning',
      MB_OK+MB_ICONSTOP+MB_APPLMODAL);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  SRec: TSearchRec;
begin
  PopupMenu1.Items[6].Enabled:=false;
  PopupMenu1.Items[6].Visible:=False;
  AFVersionCaption1.Execute;
  SetColumnSize;
  // sprawdzenie czy istnieje plik pm.xml, jesli nie to tworzy pusty
  if FindFirst('PM.xml', faArchive, SRec)<>0 then
    if not(CreateNewPMFile) then
       MessageBox(Handle,'  Can'+#39+'t create PM.xml file  ','Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
  FindClose(SRec);
  try
    DataModule1.XML1.LoadFromFile('PM.xml');
    DataModule1.XML1.Active:=True;
  except
    MessageBox(Handle,'  Can'+#39+'t open PM.xml  '+#13#10+'  Application go down  ',
      'Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
    AppError:=True;
  end;
  // kopia pliku na .bak
  BackupPMFile;
  DefaultAppSetings;
  // odczytanie ostatnich ustawien
  ReadSettingsFromXML;
  // LoadCommands;
  LoadProtocols;
  LoadTypes;
  if AppSettings.Left>(Screen.Width-AppSettings.Width) then
    AppSettings.Left:=Screen.Width-AppSettings.Width;
  if AppSettings.Left<0 then AppSettings.Left:=0;
  if AppSettings.Top>(Screen.Height-AppSettings.Height) then
    AppSettings.Top:=Screen.Height-AppSettings.Height;
  if AppSettings.Top<0 then AppSettings.Top:=0;
  // sprawdzenie czy juz jest uruchomiony
  if CheckRunningApp>1 then AppError:=True;
  GetSessionPUTTY;
  GetSessionRDP;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  with GridView1.Columns[1] do
    Options:=[coAutoSize,coCanClick,coCanSort,coCanInput,coFixedSize,
      coEditorAutoSelect,coPublicUsing,coShowTextFitHint];
  SetFontSize(AppSettings.FontSize);
  GridColumnsShow;
  with GridView1.Columns[AppSettings.Sorted] do
  begin
    if AppSettings.SortKindAsc then SortKind:=skAscending else SortKind:=skDescending;
    Sorted:=True;
  end;
  ResizeColumns;
  Autohide1.Checked:=AppSettings.Autohide;
  Timer2.Enabled:=AppSettings.Autohide;
  StayOnTop1.Checked:=AppSettings.OnTop;
  SetOnTop;
  SetActiveDel(AppSettings.InactiveDel);
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  i: integer;
begin
  MainForm.Left:=AppSettings.Left;
  MainForm.Top:=AppSettings.Top;
  MainForm.Width:=AppSettings.Width;
  MainForm.Height:=AppSettings.Height;
  FormResizeX;
  FormResizeY;
  MainForm.OnResize:=FormResize;
  if DataModule1.XML1.Active then
  begin
    XMLToGrid('');
    RowSelected:=0;
    for i:=0 to GridView1.RowCount-1 do
      if Gridview1.RowExist(i) then
        if AppSettings.PMRow=Gridview1.Cells[9,i] then RowSelected:=i;
    with GridView1 do if RowExist(RowSelected) then
    begin
      SelectedRow:=RowSelected;
      ScrollToRow(RowSelected);
    end;
  end else AppError:=True;
  SetButtons;
  if AppError then Timer1.Enabled:=True;
end;

Procedure TMainForm.GridColumnsShow;
var
  i: integer;
begin
  for i:=2 to GridView1.Columns.Count-3 do
  with TMenuItem(MainForm.FindComponent('COL'+IntToStr(i))) do
  begin
    Checked:=AppSettings.VisibleCols[i];
    GridView1.Columns[i].Visible:=AppSettings.VisibleCols[i];
  end;
  ResizeColumns;
end;

Procedure TMainForm.GridViewStoreAndClear;
var
  i: integer;
begin
  if GridView1.RowCount>0 then
    HostSelectedS:=GridView1.Cells[9,GridView1.SelectedRow] else HostSelectedS:='';
  with GridView1 do for i:=0 to Columns.Count-2 do
  begin
    ColumnsState[i].ColumnsKind:=Columns[i].SortKind;
    ColumnsState[i].ColumnsSorted:=Columns[i].Sorted;
    Columns[i].Sorted:=False;
  end;
  with GridView1 do
  begin
    SelectedRow:=0; ScrollToRow(0); ClearRows;
  end;
end;

Procedure TMainForm.GridViewRestore(sel:string);
var
  i: integer;
begin
  with GridView1 do for i:=0 to Columns.Count-2 do
  begin
    Columns[i].SortKind:=ColumnsState[i].ColumnsKind;
    Columns[i].Sorted:=ColumnsState[i].ColumnsSorted;
  end;
  if Sel<>'' then HostSelectedS:=sel;
  if (HostSelectedS<>'') and (GridView1.RowCount>0) then
    for i:=0 to GridView1.RowCount-1 do if HostSelectedS=GridView1.Cells[9,i] then
  begin
    GridView1.SelectedRow:=i;
    GridView1.ScrollToRow(i);
    Break;
  end;
  GridView1.Repaint;
end;

procedure TMainForm.XMLToGrid(s: string);
var
  i: integer;
begin
  // po edycji lub dodaniu powinnie zmieniac selected
  GridViewStoreAndClear;
  for i:=0 to HostCount-1 do
  begin
    GridView1.AddRow;
    XMLHostToGrid(ChildNodeName(i), gridview1.RowCount-1);
  end;
  GridViewRestore(s);
end;

procedure TMainForm.XMLHostToGrid(n: string; j: integer);
var
  k: integer;
  h: THostRecord;
begin
  h:=ReadHostFromXml(n);
  if copy(h.ID,1,2)='PM' then with GridView1 do      // ze wzgledu na blad XML dodatkowe sprawdzenie
  begin
    Cells[0,j]:=IntToStr(FindIconIndex(h.HostType));
    Cells[1,j]:=h.Host;
    Cells[2,j]:=h.IP;
    Cells[3,j]:=h.Protocol;
    Cells[4,j]:=h.User;
    Cells[5,j]:=BoolToStr(h.Verbosity,True);
    Cells[6,j]:=IntToStr(h.Port);
    Cells[7,j]:=h.Session;
    if not(SessionExist(Cells[7,j],Cells[3,j])) then
      for k:=1 to Columns.Count-1 do Cell[k,j].FontStyle:=[fsStrikeOut]
    else
      for k:=1 to Columns.Count-1 do Cell[k,j].FontStyle:=[];
    Cells[8,j]:=h.Description;
    Cells[9,j]:=h.ID;
    Cells[10,j]:=h.Path;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  // Add, Edit host
  if (Sender=Button1) or (Sender=Add1) then
  begin
    NewHost:=True;
  end else begin
    RowSelected:=GridView1.SelectedRow;
    NewHost:=False;
    RowToRecord(RowSelected);
  end;
  SetNewHostFormPos;
  NewHostForm.ShowModal;
  StoreNewHostFormPosition;
  SetButtons;
end;

procedure TMainForm.SetNewHostFormPos;
begin
  NewHostForm.Left:=Left+AppSettings.dLeft;
  NewHostForm.Top:=Top+AppSettings.dTop;
  if Left+AppSettings.dLeft<0 then NewHostForm.Left:=0;
  if Left+AppSettings.dLeft+NewHostForm.Width>Screen.Width then
    NewHostForm.Left:=Screen.Width-NewHostForm.Width;
  if Top+AppSettings.dTop<0 then NewHostForm.Top:=0;
  if Top+AppSettings.dTop+NewHostForm.Height>Screen.Height then
    NewHostForm.Top:=Screen.Height-NewHostForm.Height;
end;

procedure TMainForm.StoreNewHostFormPosition;
begin
  AppSettings.dTop:=NewHostForm.Top-MainForm.Top;
  AppSettings.dLeft:=NewHostForm.Left-MainForm.Left;
end;

procedure TMainForm.SetButtons;
begin
  if GridView1.RowCount>0 then
  begin
    Edit1.Enabled:=True;
    if not(AppSettings.InactiveDel) then Delete1.Enabled:=True;
  end else begin
    Delete1.Enabled:=False; Edit1.Enabled:=False;
  end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
// Delete host
begin
  RowSelected:=GridView1.SelectedRow;
  if (RowSelected>=0) and (RowSelected<GridView1.RowCount) then
  begin
    if DeleteXmlHost(GridView1.Cells[9,RowSelected]) then
    begin
      GridView1.DeleteRow(RowSelected);
      if RowSelected>0 then dec(RowSelected);
      if GridView1.RowCount>0 then
      begin
        GridView1.SelectedRow:=RowSelected;
        GridView1.ScrollToRow(RowSelected);
        AppSettings.PMRow:=GridView1.Cells[9,GridView1.SelectedRow];
      end;
      SetButtons;
      GridView1.Repaint;
    end else
      MessageBox(Handle,'  Can'+#39+'t delete host from PM.xml  ','Error',
        MB_OK+MB_ICONSTOP+MB_APPLMODAL);
  end;
  FocusControl(Button1);
end;

procedure TMainForm.GridView1SelectCell(Sender: TObject; ACol, ARow: Integer);
begin
  AppSettings.PMRow:=GridView1.Cells[9,GridView1.SelectedRow];
  GridView1.Repaint;
end;                 

procedure TMainForm.GridView1MouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  with GridView1 do
  begin
    if SelectedRow>0 then SelectedRow:=SelectedRow-1;
    AppSettings.PMRow:=Cells[9,SelectedRow];
    ScrollToRow(SelectedRow);
  end;
end;

procedure TMainForm.GridView1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  with GridView1 do
  begin
    if SelectedRow<RowCount-1 then SelectedRow:=SelectedRow+1;
    AppSettings.PMRow:=Cells[9,SelectedRow];
    ScrollToRow(SelectedRow);
  end;
end;

procedure TMainForm.GridView1DblClick(Sender: TObject);
begin
  if (GridView1.RowCount>0) and (GridView1.SelectedRow>=0) then
  begin
    RowSelected:=gridView1.SelectedRow;
    RowToRecord(RowSelected);
    if MouseOnRow<GridView1.GetRowTop(Gridview1.RowCount) then
    begin
      AppSettings.PMRow:=GridView1.Cells[9,GridView1.SelectedRow];
      ExecuteApp;
    end;
  end;
end;

procedure TMainForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  MouseOnRow:=y;
  if AppSettings.Autohide then
    if (screen.Width<(MainForm.Left+MainForm.Width)) then HideForm;
end;

procedure TMainForm.GridView1KeyPress(Sender: TObject; var Key: Char);
begin
  RowSelected:=GridView1.SelectedRow;
  RowToRecord(RowSelected);
  if (RowSelected<GridView1.RowCount) and (Key=#13) then
  begin
    AppSettings.PMRow:=GridView1.Cells[9,GridView1.SelectedRow];
    ExecuteApp;
  end;
end;

procedure TMainForm.RowToRecord(Row:integer);
begin
  with HostRecord do
  begin
    ID:=GridView1.Cells[9,Row];
    Host:=GridView1.Cells[1,Row];
    IP:=GridView1.Cells[2,Row];
    HostType:=StrToIntDef(GridView1.Cells[0,Row],-1);
    Protocol:=GridView1.Cells[3,Row];
    Port:=StrToIntDef(GridView1.Cells[6,Row],0);
    Verbosity:=StrToBool(GridView1.Cells[5,Row]);
    User:=GridView1.Cells[4,Row];
    Session:=GridView1.Cells[7,Row];
    Description:=GridView1.Cells[8,Row];
    Path:=GridView1.Cells[10,Row];
  end;
end;

Procedure TMainForm.Button5Click(Sender: TObject);
begin
  if ShellExecute(Handle,'open',PChar('putty.exe'),nil,nil,SW_SHOWNORMAL)<33 then
    MessageBox(Handle,'  Can'+#39+'t run PuTTY.exe  ','Error',
      MB_OK+MB_ICONSTOP+MB_APPLMODAL);
end;

procedure TMainForm.ExecuteApp;
var
  Command: TExecCommand;
  E, O: Pchar;
begin
  Command:=CreateCommand(HostRecord.Protocol, HostRecord);
  E:=PChar(Command.Exec);
  if Command.Option<>'' then O:=PChar(Command.Option) else O:=nil;
  if ShellExecute(Handle,'open',E,O,nil,SW_SHOWNORMAL)<33 then
    MessageBox(Handle,PAnsiChar('  Can'+#39+'t run application  '+#13#10+
      '  '+Command.Exec+' '+Command.Option+'  '),'Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
end;

function TMainForm.IDExist(id:string):boolean;
var
  i: integer;
begin
  result:=false;
  for i:=0 to GridView1.RowCount-1 do
    if id=GridView1.Cells[9,i] then
    begin
      result:=True; Break;
    end;
end;

function TMainForm.FirstFreeID:integer;
begin
  result:=1;
  while IDExist(CreateID(result)) do inc(result);
end;

procedure TMainForm.HideForm;
begin
  FormLeft:=MainForm.Left;
  while screen.Width<=(MainForm.Left+MainForm.Width) do
    MainForm.Left:= MainForm.Left-4;
 // Timer2.Enabled:=True;
end;


////////////////////////////////////////////////////////////////////////////////


procedure TMainForm.FormResize(Sender: TObject);
begin
  FormResizeX; FormResizeY;
end;

procedure TMainForm.WMGetMinMaxInfo( var Message :TWMGetMinMaxInfo );
begin
  with Message.MinMaxInfo^ do
  begin
    ptMinTrackSize.X := 190;
    ptMinTrackSize.Y := 186;
    ptMaxTrackSize.X := screen.Width;
    ptMaxTrackSize.Y := screen.Height;
  end;
  Message.Result := 0;
  inherited;
end;

procedure TMainForm.FormResizeX;
begin
  AppSettings.Width:=MainForm.Width;
  GridView1.Width:=MainForm.ClientWidth-8;
  Button2.Left:=MainForm.ClientWidth-49;
  ResizeColumns;
end;

procedure TMainForm.FormResizeY;
var
  DY: integer;
begin
  AppSettings.Height:=MainForm.Height;
  DY:=MainForm.ClientHeight-Button1.Height-4;
  Button1.Top:=DY;
  Button2.Top:=DY;
  Button5.Top:=DY;
  GridView1.Height:=DY-8;
end;

procedure TMainForm.SetFontSize(FS:integer);
var
  a: integer;
begin
  AppSettings.FontSize:=FS;
  for a:=8 to 12 do TMenuItem(MainForm.FindComponent('N'+IntToStr(a)+'FS')).Checked:=False;
  TMenuItem(MainForm.FindComponent('N'+IntToStr(FS)+'FS')).Checked:=True;
  for a:=0 to GridView1.Columns.Count-1 do GridView1.Columns[a].Font.Size:=FS;
  GridView1.Repaint;
end;

procedure TMainForm.N8FSClick(Sender: TObject);
begin
  SetFontSize(8);
end;

procedure TMainForm.N9FSClick(Sender: TObject);
begin
  SetFontSize(9);
end;

procedure TMainForm.N10FSClick(Sender: TObject);
begin
  SetFontSize(10);
end;

procedure TMainForm.N11FSClick(Sender: TObject);
begin
  SetFontSize(11);
end;

procedure TMainForm.N12FSClick(Sender: TObject);
begin
  SetFontSize(12);
end;

Procedure TMainForm.GridColumnsVisible(col:integer);
begin
  with TMenuItem(MainForm.FindComponent('COL'+IntToStr(col))) do
  begin
    Checked:=not(Checked);
    AppSettings.VisibleCols[Col]:=Checked;
    GridView1.Columns[Col].Visible:=Checked;
  end;
  ResizeColumns;
end;

Procedure TMainForm.GridColumnsVisibleAll(t:boolean);
var
  i: integer;
begin
  for i:=2 to GridView1.Columns.Count-3 do
  with TMenuItem(MainForm.FindComponent('COL'+IntToStr(i))) do
  begin
    Checked:=T;
    AppSettings.VisibleCols[i]:=T;
    GridView1.Columns[i].Visible:=T;
  end;
  ResizeColumns;
end;

Procedure TMainForm.ResizeColumns;
var
  i, ColsW, ColsU: integer;
begin
  ColsW:=0;
  with GridView1 do
  begin
    for i:=1 to Columns.Count-1 do if Columns[i].Visible then ColsW:=ColsW+ColW[i];
    ColsU:=(Width-41) div ColsW;
    for i:=2 to Columns.Count-1 do Columns[i].Width:=ColsU*ColW[i];
    Columns[1].Visible:=False;
    Columns[1].Visible:=True;
  end;                          
end;

procedure TMainForm.COL2Click(Sender: TObject);
begin
  GridColumnsVisible(2);
end;

procedure TMainForm.COL3Click(Sender: TObject);
begin
  GridColumnsVisible(3);
end;

procedure TMainForm.COL4Click(Sender: TObject);
begin
  GridColumnsVisible(4);
end;

procedure TMainForm.COL5Click(Sender: TObject);
begin
  GridColumnsVisible(5);
end;

procedure TMainForm.COL6Click(Sender: TObject);
begin
  GridColumnsVisible(6);
end;

procedure TMainForm.COL7Click(Sender: TObject);
begin
  GridColumnsVisible(7);
end;

procedure TMainForm.COL8Click(Sender: TObject);
begin
  GridColumnsVisible(8);
end;

procedure TMainForm.All1Click(Sender: TObject);
begin
  GridColumnsVisibleALl(True);
end;

procedure TMainForm.OnlyHost1Click(Sender: TObject);
begin
  GridColumnsVisibleALl(False);
end;

procedure TMainForm.GridView1SortColumn(Sender: TObject; ACol: Integer;
  Ascending: Boolean);
var
  i: integer;
begin
  AppSettings.Sorted:=Acol;
  AppSettings.SortKindAsc:=Ascending;
  for i:=0 to GridView1.RowCount-1 do if AppSettings.PMRow=GridView1.Cells[9,i] then
  begin
    GridView1.SelectedRow:=i;
    GridView1.ScrollToRow(i);
    Break;
  end;
end;

procedure TMainForm.SetOnTop;
begin
  if AppSettings.OnTop then
    SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, 0) else
    SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height, 0);
end;

procedure TMainForm.StayOnTop1Click(Sender: TObject);
begin
  StayOnTop1.Checked:=not(StayOnTop1.Checked);
  AppSettings.OnTop:=StayOnTop1.Checked;
  SetOnTop;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutForm.Left:=ClientOrigin.X-60;
  AboutForm.Top:=ClientOrigin.Y+50;
  AboutForm.ShowModal;
end;

procedure TMainForm.Timer2Timer(Sender: TObject);
begin
  if mouse.CursorPos.X<MainForm.Left then
  begin
    while screen.Width>MainForm.Left+12 do
    //while FormLeft>MainForm.Left do
      MainForm.Left:=MainForm.Left+5;
    //Timer2.Enabled:=False;
  end;
end;

procedure TMainForm.Autohide1Click(Sender: TObject);
begin
  with Autohide1 do
  begin
    Checked:=not(Checked);
    AppSettings.Autohide:=Checked;
    Timer2.Enabled:=AppSettings.Autohide;
  end;
end;

procedure TMainForm.GridView1Compare(Sender: TObject; Cell1, Cell2: TCell;
  var Compare: Integer);
var
  ip1, ip2: string;
begin
  ip1:=IPToSort(Cell1.AsString);
  ip2:=IPToSort(Cell2.AsString);
  if ip1>ip2 then Compare:=1
  else if ip1<ip2 then Compare:=-1
  else Compare:=0;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  CloseApplication;
end;

end.

