unit PM_NewHost;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Registry, ExtCtrls, ImgList, ComCtrls,
  PM_CommData, PM_XML, PM_CommFunction;

type
  TNewHostForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    ComboBox1: TComboBox;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    Edit4: TEdit;
    Button1: TBitBtn;
    Button2: TBitBtn;
    ComboBox2: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    Edit5: TEdit;
    Label9: TLabel;
    ComboBoxEx1: TComboBoxEx;
    HostType: TImageList;
    Label5: TLabel;
    Edit6: TEdit;
    Image1: TImage;
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure ComboBoxEx1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBoxEx1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit6KeyPress(Sender: TObject; var Key: Char);
    procedure Edit6Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Procedure FocusNext;
    Function FindNextActive(E:TWinControl):TWinControl;
    Function CheckAllFields:boolean;
    Function CheckReqFields:boolean;
    procedure CheckEdit1;
    procedure CheckEdit2;
    procedure CheckEdit3;
    procedure CheckEdit4;
    procedure CheckEdit6;
    procedure CheckComboBoxEx1;
    procedure CheckComboBox1;
    procedure CheckComboBox2;
    procedure SetDefaultPort;
    procedure SetNewHostForm(mode:integer);
    procedure SetNewHostFormMode0;
    procedure SetNewHostFormMode1;
    procedure ValueToRecord;
    procedure SetReqField(n: string);
    procedure LoadSessionToCombo(s: string);
    procedure LoadProtocolsToCombo;
    procedure DevIconsToCombo;
    procedure DevIconsToImageList;
    procedure SetEnableField(n: string);
    procedure LoadSettingToCombo;
  public
    { Public declarations }
  end;

var
  NewHostForm: TNewHostForm;

implementation

uses PM_Main;


{$R *.dfm}

procedure TNewHostForm.LoadProtocolsToCombo;
var
  i: integer;
begin
  Combobox1.Clear;
  for i:=0 to High(Protocols) do
    ComboBox1.Items.Add(Protocols[i].Name);
end;

procedure TNewHostForm.LoadSessionToCombo(s:string);
var
  i, j: integer;
begin
  // s - protocol
  ComboBox2.Clear;
  s:=LowerCase(Trim(s));
  for j:=0 to High(Protocols) do
  begin
    if (LowerCase(Protocols[j].Name)=s) and (LowerCase(Protocols[j].SavedSession)='putty') then
    begin
      for i:=0 to High(SessionPUTTY) do if SessionPUTTY[i]<>'' then
        ComboBox2.Items.Add(RegSessionToStr(SessionPUTTY[i]));
    end;
    if (LowerCase(Protocols[j].Name)=s) and (LowerCase(Protocols[j].SavedSession)='rdp') then
    begin
      for i:=0 to High(SessionRDP) do if SessionRDP[i]<>'' then
        ComboBox2.Items.Add(RegSessionToStr(SessionRDP[i]));
    end;
  end;
end;

procedure TNewHostForm.DevIconsToCombo;
var
  i: integer;
begin
  ComboBoxEx1.Clear;
  for i:=0 to High(DevIcons) do
    if DevIcons[i].id>=0 then
      ComboBoxEx1.ItemsEx.AddItem(DevIcons[i].Name, i+1, i+1, -1, -1, nil);
end;

procedure TNewHostForm.DevIconsToImageList;
var
  i: integer;
  SRec: TSearchRec;
  BmpFile: string;
  bm: TBitmap;
begin
  bm:=TBitmap.Create;
  HostType.Clear;
  HostType.AddMasked(Image1.Picture.Bitmap, clFuchsia);
  for i:=0 to High(DevIcons) do
  begin
    if DevIcons[i].id>=0 then
    begin
      BmpFile:=DevIcons[i].FileImage;
      if FindFirst(BmpFile, faArchive, SRec)=0 then
      begin
        try
          bm.LoadFromFile(BmpFile);
          HostType.AddMasked(bm, clFuchsia);
        except
          MessageBox(Handle,PAnsiChar('  Can'+#39+'t read file "'+BmpFile+'"  '), 'Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
        end;
      end else begin
        MessageBox(Handle,PAnsiChar('  Can'+#39+'t find file "'+BmpFile+'"  '), 'Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
      end;
      FindClose(SRec);
    end;
    if HostType.Count<=(i+1) then HostType.AddMasked(Image1.Picture.Bitmap, clFuchsia);
  end;
  bm.Free;
end;

procedure TNewHostForm.SetEnableField(n: string);
var
  i: integer;
begin
  Edit2.Enabled:=False;
  CheckBox1.Enabled:=False;
  Edit4.Enabled:=False;
  Edit3.Enabled:=False;
  Edit6.Enabled:=False;
  ComboBox2.Enabled:=False;
  for i:=0 to High(Protocols) do
    if LowerCase(Protocols[i].Name)=LowerCase(n) then
    begin
      if Protocols[i].Ip>0 then Edit2.Enabled:=True;
      if Protocols[i].Verbosity>0 then CheckBox1.Enabled:=True;
      if Protocols[i].Port>0 then Edit4.Enabled:=True;
      if Protocols[i].User>0 then Edit3.Enabled:=True;
      if Protocols[i].Path>0 then Edit6.Enabled:=True;
      if Protocols[i].Session>0 then ComboBox2.Enabled:=True;
    end;
end;

procedure TNewHostForm.SetReqField(n: string);
var
  i: integer;
begin
  Label2.Enabled:=False;
  Label6.Enabled:=False;
  Label4.Enabled:=False;
  Label5.Enabled:=False;
  Label7.Enabled:=False;
  for i:=0 to High(Protocols) do
    if LowerCase(Protocols[i].Name)=LowerCase(n) then
    begin
      if Protocols[i].Ip>0 then Label2.Enabled:=True;
      if Protocols[i].Ip>1 then Label2.Font.Style:=[fsBold] else Label2.Font.Style:=[];
      ReqFields[1].Req:=Protocols[i].Ip;
      if Protocols[i].Verbosity>1 then CheckBox1.Font.Style:=[fsBold] else CheckBox1.Font.Style:=[];
      ReqFields[4].Req:=Protocols[i].Verbosity;
      if Protocols[i].Port>0 then Label6.Enabled:=True;
      if Protocols[i].Port>1 then Label6.Font.Style:=[fsBold] else Label6.Font.Style:=[];
      ReqFields[5].Req:=Protocols[i].Port;
      if Protocols[i].User>0 then Label4.Enabled:=True;
      if Protocols[i].User>1 then Label4.Font.Style:=[fsBold] else Label4.Font.Style:=[];
      ReqFields[6].Req:=Protocols[i].User;
      if Protocols[i].Path>0 then Label5.Enabled:=True;
      if Protocols[i].Path>1 then Label5.Font.Style:=[fsBold] else Label5.Font.Style:=[];
      ReqFields[7].Req:=Protocols[i].Path;
      if Protocols[i].Session>0 then Label7.Enabled:=True;
      if Protocols[i].Session>1 then Label7.Font.Style:=[fsBold] else Label7.Font.Style:=[];
      ReqFields[8].Req:=Protocols[i].Session;
    end;
end;

procedure TNewHostForm.SetNewHostForm(mode:integer);
begin
  case mode of
    0: SetNewHostFormMode0;
    1: SetNewHostFormMode1;
  end;
end;

procedure TNewHostForm.SetNewHostFormMode0;
var
  i: integer;
begin
  Caption:=' Add new host';
  for i:=1 to 6 do
    TEdit(FindComponent('Edit'+IntToStr(i))).Text:='';
  ComboBoxEx1.ItemIndex:=-1;
  ComboBox1.ItemIndex:=1;
  ComboBox1Change(NewHostForm);
end;

procedure TNewHostForm.SetNewHostFormMode1;
var
  i: integer;
begin
  Caption:=' Edit host settings';
  // ustawienie wartosci edytowanych
  Edit1.Text:=HostRecord.Host;
  Edit2.Text:=HostRecord.IP;
  ComboBoxEx1.ItemIndex:=-1;
  for i:=0 to ComboBoxEx1.Items.Count-1 do
    if ComboBoxEx1.ItemsEx[i].ImageIndex=HostRecord.HostType then
      ComboBoxEx1.ItemIndex:=i;
  ComboBox1.ItemIndex:=ComboBox1.Items.IndexOf(HostRecord.Protocol);
  ComboBox1Change(NewHostForm);
  ComboBox2.ItemIndex:=ComboBox2.Items.IndexOf(HostRecord.Session);
  CheckBox1.Checked:=HostRecord.Verbosity;
  Edit3.Text:=HostRecord.User;
  if (HostRecord.Port>0) and (HostRecord.Port<65536) then Edit4.Text:=IntToStr(HostRecord.Port);
  Edit5.Text:=HostRecord.Description;
  Edit6.Text:=HostRecord.Path;
  for i:=0 to High(Protocols) do
  begin
    if (Protocols[i].Session>0) and (HostRecord.Protocol=Protocols[i].Name) and
      (HostRecord.Session<>'') and (HostRecord.Session<>ComboBox2.Text) then
        MessageBox(Handle,PAnsiChar('  Session "'+HostRecord.Session+'" not exist.  '),'Warning',
          MB_OK+MB_ICONWARNING+MB_APPLMODAL);
  end;
end;

procedure TNewHostForm.FormActivate(Sender: TObject);
begin
  LoadSettingToCombo;
  GetSessionPUTTY;
  GetSessionRDP;
  if NewHost then SetNewHostForm(0) else SetNewHostForm(1);
  Fields:=0;
  if Edit1.Text<>'' then
    FocusControl(ComboBoxEx1) else FocusControl(Edit1);
  CheckAllFields;
end;

Procedure TNewHostForm.FocusNext;
begin
  FocusControl(FindNextActive(ActiveControl));
end;

Function TNewHostForm.FindNextActive(E:TWinControl):TWinControl;
begin
  result:=e;
  repeat
    if result=Edit5 then result:=Button1;
    if result=ComboBox2 then result:=Edit5;
    if result=Edit6 then result:=ComboBox2;
    if result=Edit3 then result:=Edit6;
    if result=Edit4 then result:=Edit3;
    if result=CheckBox1 then result:=Edit4;
    if result=ComboBoxEx1 then result:=CheckBox1;
    if result=ComboBox1 then result:=ComboBoxEx1;
    if result=Edit2 then result:=ComboBox1;
    if result=Edit1 then result:=Edit2;
  until result.Enabled and result.Visible;
end;

procedure TNewHostForm.ValueToRecord;
begin
  if ReqFields[0].Req>0 then
    HostRecord.Host:=Edit1.Text else HostRecord.Host:='';
  if ReqFields[1].Req>0 then
    HostRecord.IP:=Edit2.Text else HostRecord.IP:='';
  if ReqFields[2].Req>0 then
    HostRecord.Protocol:=ComboBox1.Text else HostRecord.Protocol:='';
  if (ReqFields[3].Req>0) and (ComboBoxEx1.ItemIndex>=0) then
    HostRecord.HostType:=DevIcons[ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].ImageIndex-1].id else HostRecord.HostType:=0;
  if ReqFields[4].Req>0 then
    HostRecord.Verbosity:=CheckBox1.Checked else HostRecord.Verbosity:=False;
  if ReqFields[5].Req>0 then
    HostRecord.Port:=StrToIntDef(Edit4.Text,0) else HostRecord.Port:=0;
  if ReqFields[6].Req>0 then
    HostRecord.User:=Edit3.Text else HostRecord.User:='';
  if ReqFields[7].Req>0 then
    HostRecord.Path:=Trim(Edit6.Text) else HostRecord.Path:='';
  if ReqFields[8].Req>0 then
    HostRecord.Session:=ComboBox2.Text else HostRecord.Session:='';
  if ReqFields[9].Req>0 then
    HostRecord.Description:=Edit5.Text else HostRecord.Description:='';
end;

procedure TNewHostForm.ComboBox1Change(Sender: TObject);
begin
  LoadSessionToCombo(ComboBox1.Text);
  SetEnableField(Trim(ComboBox1.Text));
  SetReqField(Trim(ComboBox1.Text));
  SetDefaultPort;
  if sender=ComboBox1 then
  begin
    CheckAllFields;
    CheckReqFields;
  end;
end;

procedure TNewHostForm.SetDefaultPort;
var
  i: integer;
begin
  Edit4.Text:='';
  if ComboBox1.ItemIndex>=0 then
  begin
    for i:=0 to High(Protocols) do
      if (Protocols[i].Name=ComboBox1.Text) and (Protocols[i].Port>0) and
        (Protocols[i].DefPort>0) then Edit4.Text:=IntToStr(Protocols[i].DefPort);
  end;
end;

procedure TNewHostForm.Button1Click(Sender: TObject);
begin
  Application.ProcessMessages;
  Sleep(200);
  if CheckAllFields then
  begin
    ValueToRecord;
    if NewHost then HostRecord.ID:=CreateID(MAinForm.FirstFreeID);
    if WriteHostToXml(HostRecord,NewHost) then
    begin
      if NewHost then
        MainForm.XMLToGrid(HostRecord.ID) else MainForm.XMLHostToGrid(HostRecord.ID,RowSelected);
    end else MessageBox(Handle,'  Can'+#39+'t write to PM.xml  ','Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
    ModalResult:=mrOK;
  end else
    MessageBox(Handle,'  Some value are wrong  ','Error', MB_OK+MB_ICONSTOP+MB_APPLMODAL);
end;

function TNewHostForm.CheckReqFields:boolean;
var
  i: integer;
begin
  result:=True;
  for i:=0 to High(ReqFields) do
  begin
    if (ReqFields[i].Req=1) and not(ReqFields[i].OK) then result:=False;
    if (ReqFields[i].Req=2) and (not(ReqFields[i].OK) or ReqFields[i].Empty) then result:=False;
  end;
  Button1.Enabled:=result;
end;

function TNewHostForm.CheckAllFields:boolean;
begin
  if ReqFields[0].Req>0 then CheckEdit1;
  if ReqFields[1].Req>0 then CheckEdit2;
  if ReqFields[2].Req>0 then CheckComboBox1;
  if ReqFields[3].Req>0 then CheckComboBoxEx1;
  if ReqFields[5].Req>0 then CheckEdit4;
  if ReqFields[6].Req>0 then CheckEdit3;
  if ReqFields[7].Req>0 then CheckEdit6;
  if ReqFields[8].Req>0 then CheckComboBox2;
  result:=CheckReqFields;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TNewHostForm.CheckEdit1;
begin
  ReqFields[0].Empty:=True;
  ReqFields[0].OK:=False;
  if length(Edit1.Text)>0 then ReqFields[0].Empty:=False;
  if not(ReqFields[0].Empty) then ReqFields[0].OK:=True;
end;

procedure TNewHostForm.CheckEdit2;
var
  i: integer;
  s: string;
begin
  ReqFields[1].Empty:=True;
  s:=Edit2.Text;
  if length(s)>0 then for i:=length(s) downto 1 do
    if not(s[i] in ['0'..'9','.','a'..'z','A'..'Z','_','-',#3,#8,#22]) then delete(s,i,1);
  Edit2.Text:=s;
  if length(Edit2.Text)>0 then ReqFields[1].Empty:=False;
  ReqFields[1].OK:=True;
end;

procedure TNewHostForm.CheckEdit3;
var
  i: integer;
  s: string;
begin
  ReqFields[6].Empty:=True;
  s:=Edit3.Text;
  if length(s)>0 then for i:=length(s) downto 1 do
    if s[i] in ['<','>',';','"','@'] then delete(s,i,1);
  Edit3.Text:=s;
  if length(Edit3.Text)>0 then ReqFields[6].Empty:=False;
  ReqFields[6].OK:=True;
end;

procedure TNewHostForm.CheckEdit6;
var
  i: integer;
  s: string;
begin
  ReqFields[7].Empty:=True;
  s:=Edit3.Text;
  if length(s)>0 then for i:=length(s) downto 1 do
    if s[i] in ['<','>',';','"','@'] then delete(s,i,1);
  Edit3.Text:=s;
  if length(Edit6.Text)>0 then ReqFields[7].Empty:=False;
  ReqFields[7].OK:=True;
end;

procedure TNewHostForm.CheckEdit4;
begin
  ReqFields[5].Empty:=True;
  if (StrToIntDef(Edit4.Text,0)<1) or (StrToIntDef(Edit4.Text,0)>65535) then Edit4.Text:='' ;
  if length(Edit4.Text)>0 then ReqFields[5].Empty:=False;
  ReqFields[5].OK:=True;
end;

procedure TNewHostForm.CheckComboBoxEx1;
begin
  ReqFields[3].Empty:=True;
  ComboBoxEx1.ItemIndex:=ComboBoxEx1.Items.IndexOf(ComboBoxEx1.Text);
  if ComboBoxEx1.ItemIndex<0 then ComboBoxEx1.Text:='';
  if length(ComboBoxEx1.Text)>0 then ReqFields[3].Empty:=False;
  ReqFields[3].OK:=True;
end;

procedure TNewHostForm.CheckComboBox1;
begin
  ReqFields[2].Empty:=True;
  ComboBox1.ItemIndex:=ComboBox1.Items.IndexOf(ComboBox1.Text);
  if ComboBox1.ItemIndex<0 then
  begin
    ComboBox1.Text:='';
    ComboBox1Change(NewHostForm);
  end;
  if length(ComboBox1.Text)>0 then ReqFields[2].Empty:=False;
  ReqFields[2].OK:=True;
end;

procedure TNewHostForm.CheckComboBox2;
begin
  ReqFields[8].Empty:=True;
  ComboBox2.ItemIndex:=ComboBox2.Items.IndexOf(ComboBox2.Text);
  if ComboBox2.ItemIndex<0 then ComboBox2.Text:='';
  if length(ComboBox2.Text)>0 then ReqFields[8].Empty:=False;
  ReqFields[8].OK:=True;
end;

procedure TNewHostForm.Edit1Change(Sender: TObject);
begin
  CheckEdit1;
  CheckReqFields;
end;

procedure TNewHostForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [#13] then FocusNext;
  if Key in [#3,#8,#22,#32..#255] then Key := Key else Key := #0;
  CheckReqFields;
end;

procedure TNewHostForm.Edit2Change(Sender: TObject);
begin
  CheckEdit2;
  CheckReqFields;
end;

procedure TNewHostForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [#13] then FocusNext;
  if Key in ['0'..'9','.','a'..'z','A'..'Z','_','-',#3,#8,#22] then
    Key := Key else Key := #0;
  CheckReqFields;
end;

procedure TNewHostForm.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [#13] then FocusNext;
  if Key in ['<','>',';','"','@'] then Key := #0;
  CheckReqFields;
end;

procedure TNewHostForm.Edit3Change(Sender: TObject);
begin
  CheckEdit3;
  CheckReqFields;
end;

procedure TNewHostForm.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [#13] then FocusNext;
  if Key in ['0'..'9',#3,#8,#22] then Key := Key else Key := #0;
  if (length(Edit4.text)>=5) and (Key in ['0'..'9']) then Key := #0;
  CheckReqFields;
end;

procedure TNewHostForm.Edit4Change(Sender: TObject);
begin
  CheckEdit4;
  CheckReqFields;
end;

procedure TNewHostForm.ComboBoxEx1Change(Sender: TObject);
begin
  CheckComboBoxEx1;
  CheckReqFields;
  ComboBoxEx1.Enabled:=False;
  ComboBoxEx1.Enabled:=True;
  if NewHostForm.Visible then
    NewHostForm.FocusControl(ComboBoxEx1);
end;

procedure TNewHostForm.ComboBox2Change(Sender: TObject);
begin
  CheckComboBox2;
  CheckReqFields;
end;

procedure TNewHostForm.ComboBoxEx1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [#13] then FocusNext;
end;

procedure TNewHostForm.Edit6KeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [#13] then FocusNext;
  if Key in ['<','>',';','"','@'] then Key := #0;
  CheckReqFields;
end;

procedure TNewHostForm.Edit6Change(Sender: TObject);
begin
  CheckEdit6;
  CheckReqFields;
end;

procedure TNewHostForm.FormCreate(Sender: TObject);
begin
  LoadSettingToCombo;
end;

procedure TNewHostForm.LoadSettingToCombo;
begin
  LoadProtocolsToCombo;
  DevIconsToImageList;
  DevIconsToCombo;
end;

end.
